
/* miscellaneous defs */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>

char *findit(char *inpstr, char *filename);
char *convert(char *inpstr, char *key);
int lesser(char *a, char *b);

/* main program loop */

main()
{
char line[34], filename[1026];
char *lineptr;
FILE *fp;

tryagain:
printf("Enter filename.\n\r--> ");
fgets(filename,1020,stdin);
while ((filename[strlen(filename)-1]=='\n')
    || (filename[strlen(filename)-1]=='\r'))
	filename[strlen(filename)-1]=0;
if (!strlen(filename)) goto tryagain;
if (!(fp=fopen(filename,"r"))) goto tryagain;
fclose(fp);

printf("Enter symbol to find or press return to end.");

while (1) {
	printf("\n\r--> ");
	if (fgets(line,32,stdin)==NULL) break;
	while ((line[strlen(line)-1]=='\n') || (line[strlen(line)-1]=='r'))
		line[strlen(line)-1]=0;
	if (!strlen(line)) break;
	lineptr=line;
	if (line[0]=='0' && line[1]=='x') { lineptr++; lineptr++; }
	printf("%s",lineptr=findit(lineptr,filename));
	if (lineptr!=NULL) free(lineptr);
	}
}

/* misc. functions */

lesser(char *a, char *b)
{
long temp1, temp2;

temp1=strtol(a,(char **)NULL,16);
temp2=strtol(b,(char **)NULL,16);

if (temp1==temp2) return 0;
else if (temp1<temp2) return 1;
else return 2;
}

char *findit(char *inpstr, char *filename)
{
char key[34], myfile[1024], line[1024], prevline[1024];
char *retval;
FILE *fp;

line[0]=0;
prevline[0]=0;

retval=(char *) malloc(34);
if (retval==NULL) {
	printf("Out of memory.... something's seriously hosed.\n\r");
	exit(-1);
	}
sprintf(retval,"%s",inpstr);

sprintf(myfile,"nm -n %s",filename);
if (!(fp=popen(myfile,"r"))) { error(1); return retval; }
free(retval);

sscanf(inpstr,"%s",key);

while (1) {
	if (fgets(line,1022,fp)==NULL) { pclose(fp); return convert(prevline,key); }
	else if (lesser(line,key)==2) { pclose(fp); return convert(prevline,key); }
	else sprintf(prevline,"%s",line);
	}
printf ("WTF?  This shouldn't happen!\n\r");
return NULL;
}



char *convert(char *inpstr,char *key)
{
unsigned int offset;
char *retval;

retval=(char *) malloc(strlen(inpstr)+32);
if (retval==NULL) {
	printf("Out of memory!  This shouldn't happen!\n\r");
	exit(-1);
	}

offset=strtol(key,(char **)NULL,16)-strtol(inpstr,(char **)NULL,16);

while ((inpstr[strlen(inpstr)-1]=='\r') || (inpstr[strlen(inpstr)-1]=='\n'))
	inpstr[strlen(inpstr)-1]=0;

sprintf(retval,"%s : offset %d",inpstr,offset);
return retval;
}

/* THE END */
